#!/bin/bash
set -e

if [ "$#" -ne 2 ]; then
    echo "need 2 parameters : python_version and openssl_version"
    echo "example : 3.8.16 3.0.9"
    exit
fi

python_version="$1"
openssl_version="$2"

apt-get update -y
apt-get install debootstrap -y

rm -Rf /root/python_builddir/

# we need to specify http url instead of https because of out of date certificate authority 
# in buster by default and add security updates repo, otherwise superseeded package don't have
# the most recent supported gpg key signature
debootstrap  stretch /root/python_builddir/ http://archive.debian.org/debian/
cat << EOF > /root/python_builddir/etc/apt/sources.list
deb http://archive.debian.org/debian/ stretch main contrib non-free
deb-src http://archive.debian.org/debian/ stretch main contrib non-free
EOF

chroot /root/python_builddir/ bash -c "LANG=C apt-get update"
#debootstrap  jammy /root/python_builddir/

#chroot /root/python_builddir/ bash -c "LANG=C apt-get install software-properties-common -y"
#chroot /root/python_builddir/ bash -c "LANG=C add-apt-repository universe -y "
chroot /root/python_builddir/ bash -c "LANG=C apt-get install -y autoconf automake libtool pkg-config libpng-dev libfreetype6-dev build-essential libbz2-dev libreadline-dev libffi-dev zlib1g-dev libsqlite3-dev tk-dev libgdm-dev patchelf patch byacc wget locales software-properties-common liblzma-dev lzma libsqlite3-0"

chmod 755 step2_compile_python_in_debootstrap.sh
cp step2_compile_python_in_debootstrap.sh /root/python_builddir/root/step2_compile_python_in_debootstrap.sh

wget https://www.openssl.org/source/openssl-${openssl_version}.tar.gz --directory-prefix=/root/python_builddir/root/
wget https://www.python.org/ftp/python/${python_version}/Python-${python_version}.tgz --directory-prefix=/root/python_builddir/root/
wget https://kerberos.org/dist/krb5/1.20/krb5-1.20.1.tar.gz --directory-prefix=/root/python_builddir/root/
wget https://github.com/OpenSC/libp11/archive/refs/tags/libp11-0.4.12.tar.gz --directory-prefix=/root/python_builddir/root/


chroot /root/python_builddir bash -c "LANG=C /root/step2_compile_python_in_debootstrap.sh ${python_version} ${openssl_version}"
